"use strict";

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// One hundred millions
var satoshisInBtc = 100000000;

var FeeRate = function () {
  _createClass(FeeRate, null, [{
    key: "fromSatoshisPerK",
    value: function fromSatoshisPerK(satoshisPerK) {
      var feeRate = new FeeRate(0);
      feeRate.satoshisPerK = satoshisPerK;
      return feeRate;
    }
  }]);

  function FeeRate(feePaidInBtc, transactionSizeInBytes) {
    _classCallCheck(this, FeeRate);

    if (transactionSizeInBytes > 0) {
      var btcPerByte = feePaidInBtc / transactionSizeInBytes;
      var btcPerK = btcPerByte * 1000;
      this.satoshisPerK = btcPerK * satoshisInBtc;
    } else {
      this.satoshisPerK = 0;
    }
  }

  _createClass(FeeRate, [{
    key: "getFee",
    value: function getFee(transactionSizeInBytes) {
      var feeInSatoshis = this.satoshisPerK * transactionSizeInBytes / 1000;

      if (feeInSatoshis === 0 && transactionSizeInBytes !== 0) {
        if (this.satoshisPerK > 0) {
          feeInSatoshis = 1;
        }
        if (this.satoshisPerK < 0) {
          feeInSatoshis = -1;
        }
      }

      return parseInt(feeInSatoshis, 10);
    }
  }, {
    key: "getFeePerK",
    value: function getFeePerK() {
      return this.getFee(1000);
    }
  }]);

  return FeeRate;
}();

module.exports = FeeRate;