'use strict';

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _require = require('./constants'),
    FeeReason = _require.FeeReason;

var EstimatorBucket = function EstimatorBucket() {
  var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : -1;
  var end = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : -1;
  var withinTarget = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var totalConfirmed = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
  var inMempool = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  var leftMempool = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;

  _classCallCheck(this, EstimatorBucket);

  this.start = start;
  this.end = end;
  this.withinTarget = withinTarget;
  this.totalConfirmed = totalConfirmed;
  this.inMempool = inMempool;
  this.leftMempool = leftMempool;
};

var EstimationResult = function EstimationResult() {
  var pass = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new EstimatorBucket();
  var fail = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new EstimatorBucket();
  var decay = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
  var scale = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;

  _classCallCheck(this, EstimationResult);

  this.pass = pass;
  this.fail = fail;
  this.decay = decay;
  this.scale = scale;
};

var FeeCalculation = function FeeCalculation() {
  var est = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : new EstimationResult();
  var desiredTarget = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
  var returnedTarget = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

  _classCallCheck(this, FeeCalculation);

  this.est = est;
  this.reason = FeeReason.NONE;
  this.desiredTarget = desiredTarget;
  this.returnedTarget = returnedTarget;
};

var MempoolTransaction = function MempoolTransaction(transaction, bucketIndex) {
  _classCallCheck(this, MempoolTransaction);

  this.blockHeight = transaction.height;
  this.height = transaction.height;
  this.hash = transaction.hash;
  this.fee = transaction.fee;
  this.size = transaction.size;
  this.bucketIndex = bucketIndex;
};

module.exports = {
  EstimationResult: EstimationResult,
  EstimatorBucket: EstimatorBucket,
  FeeCalculation: FeeCalculation,
  MempoolTransaction: MempoolTransaction
};