"use strict";

/**
 * Returns index of the first element in the array which is not less than given value.
 * @param {Iterator<number>} iterable
 * @param {number} value
 * @returns {number} index
 */
var lowerBound = function lowerBound(iterable, value) {
  var array = Array.isArray(iterable) ? iterable : Array.from(iterable);
  var arrayCopy = array.slice(0);
  var closestGreaterOrEqualElement = arrayCopy.sort(function (a, b) {
    return Math.abs(value - a) - Math.abs(value - b);
  })[0];
  var index = array.indexOf(closestGreaterOrEqualElement);
  return index;
};

var getTwoDimensionalArrayWithZeros = function getTwoDimensionalArrayWithZeros(outerSize, innerSize) {
  var outer = new Array(outerSize);
  for (var i = 0; i < outerSize; i++) {
    outer[i] = new Array(innerSize).fill(0);
  }
  return outer;
};

module.exports = {
  lowerBound: lowerBound,
  getTwoDimensionalArrayWithZeros: getTwoDimensionalArrayWithZeros
};